<template>
  <teleport to="body">
    <div class="modal" v-if="show">
      <div class="modal-frame">
        <div class="modal-frame__header">{{ title }}</div>
        <div class="modal-frame__body">
          <p>{{ text }}</p>
          <div class="modal-counter" v-if="showCounter">
            <span class="modal-counter__text">Выбрано объектов: </span>
            <span class="modal-counter__count">{{ count }}</span>
          </div>
        </div>
        <div class="modal-frame__footer">
          <slot name="actions" />
        </div>
      </div>
    </div>
  </teleport>
</template>

<script>
export default {
  props: {
    title: {
      type: String,
      require: true,
    },
    text: {
      type: String,
      default: "",
    },
    count: {
      type: Number,
      default: 1,
    },
    show: {
      type: Boolean,
      default: false,
    },
    showCounter: {
      type: Boolean,
      default: true,
    },
  },
};
</script>

<style scoped>
.modal {
  background: rgba(0, 0, 0, 0.4);
  overflow: hidden;
  position: fixed;
  top: 0px;
  left: 0px;
  z-index: 999;
  width: 100%;
  height: 100%;
}

.modal .modal-frame {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  background: #ffffff;
  border-radius: 10px;
  max-width: 490px;
  width: 100%;
  padding: 40px;
  font-weight: 400;
  font-size: 14px;
  line-height: 20px;
}

.modal .modal-frame__header {
  font-weight: 500;
  font-size: 18px;
  line-height: 24px;
  margin-bottom: 20px;
}

.modal .modal-frame__body {
  margin-bottom: 40px;
}

.modal .modal-counter {
  margin-top: 20px;
  font-size: 14px;
  line-height: 18px;
}

.modal .modal-counter__text {
  color: #10171e;
  font-weight: 500;
}

.modal .modal-counter__count {
  color: #106edc;
}

.modal .modal-frame__footer {
  margin-bottom: 20px;
  float: right;
}
</style>
